/* Prototypes for the req.library for use with Lattice. */

/* Don't use this if your compiler doesn't handle ANSI style prototypes. */

/* If you aren't using a compiler that can handle pragmas, then define NOPRAGS */

#ifndef __NOPROTO
#ifndef __PROTO
#define __PROTO(a) a
#endif
#else
#ifndef __PROTO
#define __PROTO(a) ()
#endif
#endif

#ifdef NOPRAGS
#define PRAGSTATE __stdargs
#else
#define PRAGSTATE
#endif

#ifdef NOPRAGS
void __stdargs  SimpleRequest __PROTO((char *,...));
int  __stdargs  TwoGadRequest __PROTO((char *,...));
#endif

int  PRAGSTATE  FileRequester __PROTO((struct FileRequester *));
void PRAGSTATE  Center __PROTO((struct NewWindow *,int,int));
void PRAGSTATE  PurgeFiles __PROTO((struct FileRequester *));
int  PRAGSTATE  ColorRequester __PROTO((long));
int  PRAGSTATE  TextRequest __PROTO((struct TRStructure *));
char PRAGSTATE  RawKeyToAscii __PROTO((long,long,APTR));
void PRAGSTATE  MakeScrollBar __PROTO((struct ScrollBlock *,long,long,long,long));
void PRAGSTATE  MakeString __PROTO((char *,char *,char *,ULONG,ULONG,long,long));
void PRAGSTATE  MakeProp  __PROTO((char *,ULONG,ULONG,ULONG));
void PRAGSTATE  MakeGadget __PROTO((char *,char *,ULONG,ULONG));

BOOL PRAGSTATE  GetLong __PROTO((struct GetLongStruct *));
BOOL PRAGSTATE  NewGetString __PROTO((struct GetStringStruct *));

