;------------------------------------------------------------------------------
;
;   File    :	BitStream_asm.i
;
;   Author  :	Stphane TAVENARD
;
;   $VER:   BitStream_asm.i  1.0  (23/06/1995)
;
;   (C) Copyright 1995-1995 Stphane TAVENARD
;	All Rights Reserved
;
;   #Rev|   Date   |			  Comment
;   ----|----------|--------------------------------------------------------
;   0	|12/04/1995| Initial revision					  ST
;   1	|03/06/1995| First release (no more C code)                       ST
;   2	|23/06/1995| Aminet release					  ST
;
;   ------------------------------------------------------------------------
;
;   BitStream files handling defintion
;
;------------------------------------------------------------------------------

			IFND  BITSTREAM_I
BITSTREAM_I		set   1

;  Bitstream structure

			rsreset
BSTR_file_ptr		rs.l  1
BSTR_mode		rs.l  1
BSTR_buffer_size	rs.l  1
BSTR_buffer		rs.l  1
BSTR_current_bit_index	rs.l  1
BSTR_remaining_bits	rs.l  1
BSTR_bitstream_size	rs.l  1
BSTR_end_of_stream	rs.l  1
BSTR_SIZEOF		rs.l  0


BSTR_MODE_READ		equ   0
BSTR_MODE_WRITE 	equ   1

BSTR_MAX_BITS		equ   32    ; # max of bits to read

			ENDC	    ; BITSTREAM_I
