#ifndef PAINT
#define PAINT

#include "crinkle.h"

/* -------------------------------------------------------------------- */
/* colour code definitions												*/
/* -------------------------------------------------------------------- */

typedef int Col;
typedef unsigned short Gun;

#define BLACK		0
#define WHITE		1
#define SEA_LIT		2
#define SEA_UNLIT	3
#define SKY			4
#define BAND_BASE	5

#ifndef BAND_SIZE
#	define BAND_SIZE	80
#endif

#define N_BANDS		3
#define DEF_COL		(BAND_BASE + (N_BANDS * BAND_SIZE))
#define MIN_COL		(BAND_BASE + (N_BANDS * 2))
#define COL_RANGE	65535

void set_clut( int, Gun *, Gun *, Gun * );
Height *extract( Strip *s );
void init_artist_variables( void );
Col *makemap( Height *a, Height *b, Height *shadow );
Col *camera( Height *a, Height *b, Height *shadow );
Col *mirror( Height *a, Height *b, Height *shadow );

#endif
