/*
**	card.h - header for assembly routines in card.a
**	Copyright  1995-96 Michael Letowski
*/

#ifndef CARD_H
#define CARD_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef SUPPORT_TYPES_H
#include <support/types.h>
#endif

#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif


/*
**	Public prototypes
*/
ASM VOID CopyColors(R_A0 ULONG *cRegs, R_A1 struct ColorRegister *cMap,
										R_D0 ULONG numCols);
ASM VOID CopyCard(R_A0 struct BitMap *bm, R_A1 MPTR buffer, R_D0 ULONG num,
									R_D1 ULONG h, R_D2 ULONG d, R_D3 ULONG lSize);

#endif	/* CARD_H */
