/*
**	dispatch.h - dispatcher interface for REKO DataType class
**	Copyright  1995-96 Michael Letowski
*/

#ifndef DISPATCH_H
#define DISPATCH_H

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef DATATYPES_PICTURECLASS_H
#include <datatypes/pictureclass.h>
#endif

#ifndef INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif

#ifndef SUPPORT_TYPES_H
#include <support/types.h>
#endif

#ifndef CLASSBASE_H
#include "classbase.h"
#endif


/*
**	Prublic constants
*/
#define DATATYPENAME		"reko.datatype"
#define SUPERCLASSNAME	PICTUREDTCLASS


/*
**	Public functions prototypes
*/
Class *InitClass(struct ClassBase *cb);

#endif	/* DISPATCH_H */
