/* SFX Arexxtester */

OPTIONS RESULTS

ADDRESS REXX_SFX

SetFXParam 'FX_OctaveDown' 'Interpolate' '1'
SetFXParam 'FX_OctaveUp' 'Interpolate' '1'

GetActiveBuffer
buf2=RESULT

IF buf2<9999 THEN DO
	FX_OctaveDown buf2
	IF RC~=0 THEN CALL AppError('FX_OcatevDown',RC)
	ELSE buf1=RESULT

	FX_OctaveUp buf1
	IF RC~=0 THEN CALL AppError('FX_OcatevUp',RC)
	ELSE buf2=RESULT
	RemoveBuffer buf1

	FX_OctaveDown buf2
	IF RC~=0 THEN CALL AppError('FX_OcatevDown',RC)
	ELSE buf1=RESULT
	RemoveBuffer buf2

	FX_OctaveUp buf1
	IF RC~=0 THEN CALL AppError('FX_OcatevUp',RC)
	ELSE buf2=RESULT
	RemoveBuffer buf1
	SetActiveBuffer buf2
END
ActivateSFX												/* fertig */

EXIT

AppError:PROCEDURE
	cmd=arg(1)
	ret=arg(2)
	SAY '[4m[33mApplication Error[31m[24m';say
	SAY 'Command 'cmd' failed with Returncode 'ret
	SELECT
		WHEN ret='1' THEN SAY '	=> unknown command'
		WHEN ret='2' THEN SAY '	=> unknown parameter'
		OTHERWISE SAY '	=> unknown returncode'
	END
	SAY
RETURN
