/* SFX Arexxtester */

options results

ADDRESS REXX_SFX

say '[4m[32mSFX-ArexxTester[31m[24m';say;

SelLoader 'RAW';
if RC~=0 then call AppError('SelLoader',RC);
say 'press key to continue';
pull;

LoadSample 'misc:px-b1';
if RC~=0 then call AppError('LoadSample',RC);
say 'press key to continue';
pull;

LoadSample 'misc:px-b2';
if RC~=0 then call AppError('LoadSample',RC);
say 'press key to continue';
pull;

SetActiveBuffer 'px-b1';
if RC~=0 then call AppError('SetActiveBuffer',RC);
say 'press key to continue';
pull;

RenameActiveBuffer 'px-bass1';
if RC~=0 then call AppError('RenameActiveBuffer',RC);
say 'press key to continue';
pull;

ActivateSFX;
if RC~=0 then call AppError('ActivateSFX',RC);
say 'press key to exit';
pull;

ExitSFX;
if RC~=0 then call AppError('ExitSFX',RC);

exit

AppError:procedure
	cmd=arg(1);
	ret=arg(2);
	say '[4m[33mApplication Error[31m[24m';say;
	say 'Command 'cmd' failed with Returncode 'ret;
	select
		when ret='1' then say '	=> unknown command';
		when ret='2' then say '	=> unknown parameter';
		otherwise say '	=> unknown returncode';
	end
	say;
return
