***************************************************************************************
* New Lister subroutines for DOpusFuncs.s					      *
***************************************************************************************
NewSource
	Tst.l	NewSource_S(a5)
	Bne.s	NewSource_DoIt
	RTS
NewSource_DoIt
	Move.l	SourceDir_K(a5),a0		Dir to read in, or null.
	Move.l	SourcePos_K(a5),a1		Dimensions to use, or null.
	Lea	Source_Handle(a5),a2		-._ Buffer to write
	Move.w	#Source_HandleLen,d7		-'  new handle into.
	Bsr	NewLister

	Lea	Source_Handle(a5),a0		Handle of lister.
	Lea	Set_Source_SubCommand(pc),a1	Want to make it the source lister.
	Sub.l	a2,a2				Default to not being locked.
	Tst.l	SourceLock_S(a5)		Do they want it Locked as source?
	Beq.s	NewSource_SkipLock
	Lea	Set_Lock_SubCommand(pc),a2	If so, here's the 'lock' command.
NewSource_SkipLock
	Bra	ListerSet
;;;;;;;	RTS for us.
***************************************************************************************
NewDest
	Tst.l	NewDest_S(a5)
	Bne.s	NewDest_DoIt
	RTS
NewDest_DoIt

	Move.l	DestDir_K(a5),a0		Dir to read in, or null.
	Move.l	DestPos_K(a5),a1		Dimensions to use, or null.
	Lea	Dest_Handle(a5),a2		-._ Buffer to write
	Move.w	#Dest_HandleLen,d7		-'  new handle into.
	Bsr	NewLister

	Lea	Dest_Handle(a5),a0		Handle of lister.
	Lea	Set_Dest_SubCommand(pc),a1	Want to make it the dest lister.
	Sub.l	a2,a2				Default to not being locked.
	Tst.l	DestLock_S(a5)			Do they want it Locked as dest?
	Beq.s	NewDest_SkipLock
	Lea	Set_Lock_SubCommand(pc),a2	If so, here's the 'lock' command.
NewDest_SkipLock
	Bra	ListerSet
;;;;;;;	RTS for us.
	