/*
**
**  1995 Christopher Landmark Naas
**  All Rights Reserved Worldwide
**  Freely distributable as long as you do not change or edit any of
**  the files in the archive.
**
**  If you use this script, you *must* send me either an EMail or a
**  postcard telling me you are doing so.
**
**  EMail: christon@oslonett.no
**  SMail: Christopher Naas
**         Solveien 3a
**         1533 Moss
**         Norway
**
**
**
**  Description:
**
**  Opens or closes dopus listers in 4.12 format. Remembers the paths
**  used before closing and uses them when the listers are opened again.
**
*/
address DOPUS.1

OPTIONS RESULTS

if open(file,"env:DopusListers",R) then do
	open(file2,"env:DopusListersPath",W)

	addressen = readln(file)

	lister query addressen path
	writeln(file2,result)

	lister close addressen


	addressen = readln(file)

	lister query addressen path
	writeln(file2,result)

	lister close addressen

	close(file2)
	close(file)

	address command "run >nil: delete env:DopusListers"
end
else
if open(file,"env:DopusListers",W) then do
	open(file2,"env:DopusListersPath",R)

	pathen = readln(file2)
	lister new '160/1/400/700 'pathen

	writeln(file,result)

	pathen = readln(file2)
	lister new '560/1/400/700 'pathen

	writeln(file,result)

	close(file)
end
