/* Graphik Import in WordWorth mittels MetaView */

METAVIEW = 'work:Aminet/MetaView/MetaView' /* Please complete the path */

OPTIONS RESULTS
SIGNAL ON FAILURE
SIGNAL ON SYNTAX

WWPORT = ADDRESS()
say WWPORT
if (LEFT(WWPORT, 9) ~= "WORDWORTH") then do   /* not started from WordWorth */
    say "Please start me from Wordworth!"
    EXIT
end

do NUMBER = 0 to 20                           /* create new MetaView process */
    if (SHOW(PORTS,"METAVIEW." || NUMBER) = 0) then
    leave
end

OPTIONS FAILAT 5                              /* enable warnings for WaitForPort */
ADDRESS COMMAND
    "run " || METAVIEW || " NODISPLAY"
    MVPORT = "METAVIEW." || NUMBER
    "WaitForPort " || MVPORT

OPTIONS FAILAT 21                             /* ignore errors */

ADDRESS VALUE WWPORT
    REQUESTFILE PATH "Bilder:" TITLE "Please select GFX file"
    FILENAME = result

ADDRESS VALUE MVPORT
    LOAD FILENAME
    SAVE "t:test.cgm" AS CGM
    QUIT

ADDRESS VALUE WWPORT
    REQUESTNOTIFY PROMPT "Please select >t:test.cgm<."
    PLACEPICTURE

EXIT

FAILURE:
    ADDRESS VALUE WWPORT
    REQUESTNOTIFY PROMPT "Can't find" METAVIEW "!"
    EXIT

SYNTAX:
    say "Error on line" SIGL ":" ERRORTEXT(RC) "!"
    EXIT
