/*------------------------------------------------------------------------------

    File    :	mpega_decode.h

    Author  :	Stphane TAVENARD

    $VER:   mpega_decode.h  1.0  (23/06/1995)

    (C) Copyright 1995-1995 Stphane TAVENARD
	All Rights Reserved

    #Rev|   Date   |			  Comment
    ----|----------|--------------------------------------------------------
    0	|27/05/1995| Initial revision					  ST
    1	|23/06/1995| First release (aminet)                               ST

    ------------------------------------------------------------------------

    Defintion of MPEG audio decode functions

------------------------------------------------------------------------------*/

#ifndef MPEGA_DECODE_H
#define MPEGA_DECODE_H

#include "Mpega_decode_asm.h"

#define BSTR_BUFFER_SIZE  16384   /* Bit stream buffer */

frame_params *MPEGA_open( void );
frame_params *MPEGA_close( frame_params *fr_ps );

int MPEGA_init_decode( frame_params *fr_ps );

int MPEGA_write_out( frame_params *fr_ps );

int MPEGA_decode_frame( frame_params *fr_ps );

#endif /* MPEGA_DECODE_H */

