/*------------------------------------------------------------------------------

    File    :	user_interface.h

    Author  :	Stphane TAVENARD

    $VER:   user_interface.h  1.0  (23/06/1995)

    (C) Copyright 1995-1995 Stphane TAVENARD
	All Rights Reserved

    #Rev|   Date   |			  Comment
    ----|----------|--------------------------------------------------------
    0	|05/06/1995| Initial revision
    1	|23/06/1995| First release (aminet)

    ------------------------------------------------------------------------

    Definition for User MPEG Audio interface

------------------------------------------------------------------------------*/

#ifndef USER_INTERFACE_H
#define USER_INTERFACE_H

#define MAX_NAME_SIZE 256

#define DFLT_OPEXT  ".dec"  /* default output file name extension */

void USIN_get_parameters( int argc, char **argv, frame_params *fr_ps );
/*--------------------------------------------------------------------
   Get MPEG Audio decode parameters
*/

void USIN_display_info( frame_params *fr_ps );
/*-------------------------------------------
   display current frame info
   -> exit if display_header_only is set
*/

void USIN_display_frame_number( frame_params *fr_ps );
/*---------------------------------------------------
   display current frame number
   -> exit if display_header_only is set
*/

void USIN_epilog( frame_params *fr_ps );
/*-------------------------------------
   Write epilog info
*/


#endif /* USER_INTERFACE_H */
