/*
ShowPic V1.00  24-Feb-96
by Jan Hagqvist
*/

MODULE 'datatypes/datatypesclass','datatypes','datatypes/pictureclass','datatypes/datatypes',
       'intuition/intuition','intuition/screens','utility/tagitem','intuition/gadgetclass',
       'dos','dos/dos'

DEF mywin,args,mypic:gadget,mypicflags,imsg
CONST WINIDCMP=IDCMP_CLOSEWINDOW OR IDCMP_CHANGEWINDOW
CONST WINFLAGS=WFLG_DRAGBAR OR WFLG_CLOSEGADGET OR WFLG_DEPTHGADGET OR WFLG_SIMPLE_REFRESH OR WFLG_NOCAREREFRESH OR WFLG_ACTIVATE OR WFLG_SIZEGADGET

PROC main()
 WriteF('ShowPic V1.00  24-Feb-96  by Jan Hagqvist\n')
 args:=GetArgStr()
 PutChar(args+StrLen(args)-1,0)
 imsg:=Open(args,MODE_OLDFILE)
 IF imsg<>0
  Close(imsg)
  IF datatypesbase:=OpenLibrary('datatypes.library',0)
   mypic:=NewDTObjectA(args,[DTA_SOURCETYPE,DTST_FILE,DTA_GROUPID,GID_PICTURE,
	GA_LEFT,4,GA_TOP,11,GA_RELWIDTH,-22,GA_RELHEIGHT,-13,
	TAG_DONE])
   IF mypic<>0
    IF mywin:=OpenW(0,0,640,256,WINIDCMP,WINFLAGS,'Picture Window',0,WBENCHSCREEN,0,0)
     AddDTObject(mywin,0,mypic,-1)
     REPEAT
      mypicflags:=mypic.specialinfo+46
      Delay(25)
     UNTIL (^mypicflags AND 1)=FALSE
     RefreshDTObjectA(mypic,mywin,0,0)
     waitmsg()
     RemoveDTObject(mywin,mypic)
     DisposeDTObject(mypic)
     CloseW(mywin)
    ELSE
     WriteF('\nCan\at open window\n')
    ENDIF
   ELSE
    WriteF('\s',PrintFault(IoErr(),'\nLoad error'))
   ENDIF
   CloseLibrary(datatypesbase)
  ELSE
   WriteF('\nUnable to open datatypes.library\n')
  ENDIF
 ELSE
  WriteF('\nCan\at open file: \s\n',args)
 ENDIF
ENDPROC

PROC waitmsg()
 REPEAT
  imsg:=WaitIMessage(mywin)
  IF imsg=IDCMP_CHANGEWINDOW THEN RefreshDTObjectA(mypic,mywin,0,0)
 UNTIL imsg=IDCMP_CLOSEWINDOW
ENDPROC
