#ifndef GLOBAL_H
#define GLOBAL_H

extern Fold *top;
extern int levels;
extern int stop;
extern int smooth;
extern int cross;
extern int slope;
extern int snooze_time;
extern int request_clear;
extern int n_col;
extern int band_size;
extern int e_events;
extern double mix;
extern double midmix;
extern double fdim;
extern double start;
extern double mean;
extern double varience;
extern double shift;
extern double delta_shadow;
extern double stretch;
extern double contour;
extern double ambient;
extern double contrast;
extern double vfract;
extern double altitude;
extern double distance;
extern double phi;
extern double alpha;
extern double shadow_slip;
extern double shadow_register;
extern double cos_phi;
extern double sin_phi;
extern double tan_phi;
extern double x_fact;
extern double y_fact;
extern Height sealevel;
extern Height forceheight;
extern int width;
extern int seed;
extern unsigned char red[256], green[256], blue[256];
extern int height;
extern double vangle;
extern double tan_vangle;
extern double vscale;
extern double viewpos;
extern double viewheight;
extern double focal;
extern Height *shadow;
extern Height *a_strip, *b_strip;

#endif
